/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is tkishdemos.
 *
 * The Initial Developer of the Original Code is
 * M.D. Nauta.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var dialogWindow;

function initialize() {
	setGlobalHash();
}

function setGlobalHash() {
	if (window.opener) {
		if (!("checkbuttonHash" in window.opener)) {
			window.opener.checkbuttonHash = new checkHashClass();
		}
		window.top.hash = window.opener.checkbuttonHash;
		setCheckAttributes();
	} else {
		window.top.hash = new checkHashClass();
	}
}

function checkHashClass() {
	var checkboxes = document.getElementsByTagName('checkbox');
	for (var i=0; i<checkboxes.length; ++i) {
		if (checkboxes.item(i).getAttribute('checked') &&
			checkboxes[i].getAttribute('checked')=='true') {
			this[checkboxes[i].getAttribute('id')] = 1;
		} else {
			this[checkboxes[i].getAttribute('id')] = 0;
		}
	}
}

function setCheckAttributes() {
	for (var i in hash) {
		if (hash[i] == 1) {
			document.getElementById(i).checked = "true";
		} else {
			document.getElementById(i).removeAttribute('checked');
		}
	}
}

function setvar(evt) {
	var el = evt.target;
	var stringbundle = document.getElementById('strings');
	if (el.getAttribute('checked') && el.getAttribute('checked') == 'true') {
		hash[el.getAttribute('id')] = 1;
	} else {
		hash[el.getAttribute('id')] = 0;
	}
	if (dialogWindow && ! dialogWindow.closed) {
		dialogWindow.addRows(hash,stringbundle);
	}
}

function openShowVarsDialog() {
	if (dialogWindow && ! dialogWindow.closed) dialogWindow.close();
	var stringbundle = document.getElementById('strings');
	dialogWindow=window.openDialog(
		'chrome://tkishdemos/content/showVars_dialog.xul',
		'checkbutton_dialog',
		'chrome,resizable=yes,dependent=yes',
		hash,
		stringbundle);
}
