var mouseScreenY; // The previous coordinate of the mouse used in scanning.
var activeListbox;

function startScan(evt) {
	if (evt.button == 1 && evt.target.nodeName == 'listitem') {
		activeListbox = evt.target.parentNode;
		mouseScreenY = evt.screenY;
		var main = document.documentElement;
		main.addEventListener('mousemove',scanListbox,false);
		main.addEventListener('mouseup',endScan,false);
		main.addEventListener('mouseout',mouseGone,true);
	}
}

function scanListbox(evt) {
	var index = activeListbox.getIndexOfFirstVisibleRow();
	if (evt.screenY > mouseScreenY) {
		activeListbox.scrollToIndex(index-1);
	} else {
		if (evt.screenY < mouseScreenY) activeListbox.scrollToIndex(index+1);
	}
	mouseScreenY = evt.screenY;
}

function endScan(evt) {
	var main = document.documentElement;
	main.removeEventListener('mousemove',scanListbox,false);
	main.removeEventListener('mouseout',mouseGone,true);
	main.removeEventListener('mouseup',endScan,false);
}

function mouseGone(evt) {
	// Mouse moves out of the appication window.
	// this routine doesn't work because the condition is never satisfied.
	if (evt.target == document.documentElement) endScan(evt);
}

// I use dragAndDrop because the alternative, listen to a mousedown which starts a mouseOver etc. is more messy and less stable (at least in the way I implemented it).
var listboxScrollable = {
onDragStart: function (evt,transferData,action) {
	if (evt.target.nodeName=='listitem') {
			activeListbox = evt.target.parentNode;
			transferData.data = new TransferData();
			transferData.data.addDataForFlavour("text/unicode","dummy");
	}
	},
getSupportedFlavours: function () {
	var flavours = new FlavourSet();
	flavours.appendFlavour("text/unicode");
	return flavours;
	},
onDragOver: function (evt,flavour,session) {
	var selectedListItem = activeListbox.selectedItem;
	var ySelTop = selectedListItem.boxObject.screenY;
//	ySelTop += activeListbox.getItemAtIndex(0).boxObject.screenY -
//		activeListbox.getItemAtIndex(activeListbox.getIndexOfFirstVisibleRow()).boxObject.screenY; 
//	Why is the screenY set to 0 if an item disappears under the top
//	boundary of the listbox when scrolling?
//	Workaroud: make assumption all boxes are of equal height.
	var visIndex = activeListbox.getIndexOfFirstVisibleRow();
	ySelTop -= visIndex*activeListbox.getItemAtIndex(visIndex).boxObject.height;
	var ySelBottom = ySelTop + selectedListItem.boxObject.height;
	if (evt.screenY<ySelTop) {
		activeListbox.selectedItem =
			activeListbox.getPreviousItem(selectedListItem,1);
	} else {
		if (evt.screenY>ySelBottom) 
			activeListbox.selectedItem =
				activeListbox.getNextItem(selectedListItem,1);
	}
	activeListbox.ensureElementIsVisible(activeListbox.selectedItem);
	}
}
