/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is tkishdemos.
 *
 * The Initial Developer of the Original Code is
 * M.D. Nauta.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var statusStack=[];
var console = Components.classes["@mozilla.org/consoleservice;1"].getService();
console.QueryInterface(Components.interfaces.nsIConsoleService);
if (!console) alert("Can't open the console for output.");
var checkDialog;
var radioDialog;

function initialize() {
	var menubar = document.getElementById('theMenubar');
	menubar.addEventListener('DOMAttrModified',menuActivated,false);
	setGlobalHashes();
}

function menuActivated(evt) {
	// onmouseover would not cope with keyboard navigation.
	if (evt.attrName == "_moz-menuactive") {
		var statusbar = document.getElementById('statusbar');
		if (evt.newValue == "true") {
			statusStack.push(statusbar.getAttribute('label'));
			statusbar.setAttribute('label',evt.target.getAttribute('label'));
		} else {
			statusbar.setAttribute('label',statusStack.pop());
		}
	}
}

function errorWarning(evt) {
	alert(document.getElementById('strings').getFormattedString(
		'errorString',[evt.target.getAttribute('label')]));
}

function print2console(str) {
	var strbundle = document.getElementById('strings');
	console.logStringMessage(strbundle.getString(str));
}

function setGlobalHashes() {
	if (window.opener) {
		if (!("menuCheckHash" in window.opener)) {
			window.opener.menuCheckHash = new CheckHashClass();
		}
		window.top.checkHash = window.opener.menuCheckHash;
		setCheckAttributes();
	} else {
		window.top.checkHash = new CheckHashClass();
	}
	window.top.radioHash = new RadioHashClass();
}

function CheckHashClass() {
	var checkboxes = document.getElementById('carCheck').getElementsByTagName('menuitem');
	for (var i=0; i<checkboxes.length-1; ++i) {
		if (checkboxes.item(i).getAttribute('checked') &&
			checkboxes[i].getAttribute('checked')=='true') {
			this[checkboxes[i].getAttribute('id')] = 1;
		} else {
			this[checkboxes[i].getAttribute('id')] = 0;
		}
	}
}

function RadioHashClass() {
	var radios = document.getElementById('radioGroups').getElementsByTagName('menuitem');
	for (var i=0; i<radios.length; ++i) {
		if (radios.item(i).getAttribute('checked') == 'true') {
			this[radios[i].getAttribute('name')] =
				radios[i].getAttribute('id');
		}
	}
}

function setCheckAttributes() {
	for (var i in checkHash) {
		if (checkHash[i] == 1) {
			document.getElementById(i).setAttribute('checked','true');
		} else {
			document.getElementById(i).removeAttribute('checked');
		}
	}
}

function setCheckHash(evt) {
	var menuitem = evt.target;
	var stringbundle = document.getElementById('strings');
	if (menuitem.getAttribute('checked') && 
		menuitem.getAttribute('checked') == 'true') {
		checkHash[menuitem.getAttribute('id')] = 1;
	} else {
		checkHash[menuitem.getAttribute('id')] = 0;
	}
	if (checkDialog && ! checkDialog.closed) {
		checkDialog.addRows(checkHash,stringbundle);
	}
}

function setRadioHash(evt) {
	var menuitem = evt.target;
	var stringbundle = document.getElementById('strings');
	radioHash[menuitem.getAttribute('name')] =
		menuitem.getAttribute('id');
	if (radioDialog && ! radioDialog.closed) {
		radioDialog.addRows(radioHash,stringbundle);
	}
}
function openShowCheckVarsDialog() {
	if (checkDialog && ! checkDialog.closed) checkDialog.close();
	var stringbundle = document.getElementById('strings');
	checkDialog = window.openDialog(
		'chrome://tkishdemos/content/showVars_dialog.xul',
		'menuCheck_dialog',
		'chrome,resizable=yes,dependent=yes',
		checkHash,
		stringbundle);
}

function openShowRadioVarsDialog() {
	if (radioDialog && ! radioDialog.closed) radioDialog.close();
	var stringbundle = document.getElementById('strings');
	radioDialog = window.openDialog(
		'chrome://tkishdemos/content/showVars_dialog.xul',
		'menuRadio_dialog',
		'chrome,resizable=yes,dependent=yes',
		radioHash,
		stringbundle);
}
